import pyvisa
import AWG_7000

try:
    # Initialize VISA
    rm = pyvisa.ResourceManager()

    # List connected resources
    resources = rm.list_resources()
    print(f"\n\n\nConnected devices: {resources}")

    #Instrument TCP/IP address
    address_listed = resources[1]
    address_not_listed = "TCPIP0::192.168.0.55::inst0::INSTR"

    #If you use NI MAX or similar, you can also use one of the adresses in the list 
    master = rm.open_resource(address_not_listed)

    #Master Encoding: Necessary if you use non-ascii characters, like accented vocals.
    master.encoding = "latin-1"

    #Initialize AWG
    AWG = AWG_7000.AWG7000(master, True)
except Exception as e: print(f"The following exception has occured while connecting with the instrument: {e}")



##################################################################################
#Channel settings
amplitude_scale = 100 #%
analog_skew = 0 #s
baseline_offset = 0 #V
vocm = 0 #V
polarity = AWG_7000.Polarity.Normal
fine_skew = 0 #s
correction_offset = 0 #V
keeplastmode = AWG_7000.KeepLastMode.KeepLast
offset_on_stop = 0
optimization = AWG_7000.ChannelOptimization.High_Linearity
overshoot = 0
flatness_compensation = AWG_7000.State.OFF
channel_value_on_stop_state = AWG_7000.KeepLastMode.KeepLast
output_value_on_stop = 0

#Sequencer parameters
format = AWG_7000.Format.Amplitude_offset
analog_waveform_names = [["SINE", "SINE"],
                  ["RAMP", "RAMP"],
                  ["SQUARE", "SQUARE"]]
amplitudes = [[1, 1.5],
               [0.75, 0.75],
               [1, 1.2]]
offsets = [[0, 0],
            [0, 0.3],
            [0, 0]]
decreasing_strategies = [[AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation],
                         [AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation],
                         AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation]
increasing_strategies = [[AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation],
                         [AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation],
                         [AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation]]
sub_lengths = [[16384, 16384],
               [16384, 16384],
               [16384, 16384]]
delays = [[0, 0],
          [0, 0],
          [0, 0]]
output_formats = [[AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform],
                  [AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform],
                  [AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform]]
entry_lengths = [16384, 16384, 16384]
repetitions = [1, 1, 1]
sequencer_length = len(analog_waveform_names)
digital_waveforms = ["CLOCK", "COUNTER", "COUNTER"]
marker_custom_pattern = ["", "", ""]
##################################################################################



try:
    AWG.Initialize(True, True)

    AWG.SetSequencerLength(sequencer_length, AWG_7000.SetValue.PRESENT)

    AWG.ConfigureGeneralSettings(AWG_7000.OperatingMode.Full_rate, AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.DecreasingStrategy.Decimation, AWG_7000.RunMode.Continuous,
                                 AWG_7000.WaitTriggerState.First_sample, 1, AWG_7000.BurstSelection.NumberCycles, AWG_7000.JumpMode.AfterRepetitions)

    #Program all wanted sequencer entries
    for i in range(sequencer_length):
        entry = AWG_7000.SequencerEntry(entry_number=i+1, analog_waveform_names=analog_waveform_names[i], amplitudes=amplitudes[i], offsets=offsets[i],
                                        decreasing_strategies=decreasing_strategies[i], increasing_strategies=increasing_strategies[i], sub_lengths=sub_lengths[i],
                                        delays=delays[i], digital_waveform_name=digital_waveforms[i], custom_pattern=marker_custom_pattern[i], length=entry_lengths[i],
                                        repetitions=repetitions[i], output_formats=output_formats[i])
        AWG.ConfigureSequencerElement(entry)
    
    for i in range(int(AWG.GetChannelsOutputNumber())): AWG.SetOutputState(AWG.channels[i], AWG_7000.State.ON)
    
    for channel in AWG.channels:
        AWG.ConfigureChannelSettings(channel, 100, analog_skew, fine_skew, correction_offset, vocm, keeplastmode, polarity, offset_on_stop, baseline_offset,
                                     optimization, overshoot, flatness_compensation, channel_value_on_stop_state, output_value_on_stop)

    for channel in AWG.channels: AWG.SetOutputState(channel, AWG_7000.State.ON)




    while(True):
        if input("Press enter to start\n") == "":
            AWG.AWGStart()
            break
    while(True):
        if input("Press enter to stop") == "":
            AWG.AWGStop()
            break

    AWG.Close()
except Exception as e: print(f"The following exception has occured: {e}")